﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Create委托
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 两个数求较大值
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <returns></returns>
        int Max(int x, int y)
        {
            return x > y ? x : y;
        }

        /// <summary>
        /// 两个数求较小值
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <returns></returns>
        int Min(int x, int y)
        {
            return x < y ? x : y;
        }

        ///创建与上面求较大值和较小值具有相同签名的一个委托
        delegate int MyDelegate(int x, int y);

        MyDelegate md = null;

        private void BtnReturn_Click(object sender, EventArgs e)
        {
            if (this.md == null)
            {
                MessageBox.Show("委托md没有指向任何方法！");
                return;
            }

            int FirstValue = int.Parse(this.TbFirst.Text);
            int SecondValue = int.Parse(this.TbSecond.Text);
            MessageBox.Show(md(FirstValue, SecondValue).ToString());
        }

        private void RbMax_CheckedChanged(object sender, EventArgs e)
        {
            if (RbMax.Checked == true)
            {
                md = new MyDelegate(Max);
            }
        }

        private void RbMin_CheckedChanged(object sender, EventArgs e)
        {
            if (RbMin.Checked == true)
            {
                md = new MyDelegate(Min);
            }
        }
    }
}
